clang 8.0.0

Public Member Functions | List of all members
clang::ExternalPreprocessingRecordSource Class Referenceabstract

An abstract class that should be subclassed by any external source of preprocessing record entries. More...

`#include "clang/Lex/PreprocessingRecord.h"`

Inheritance diagram for clang::ExternalPreprocessingRecordSource:
[legend]

## Public Member Functions
virtual | ~ExternalPreprocessingRecordSource ()
virtual PreprocessedEntity * | ReadPreprocessedEntity (unsigned Index)=0
| Read a preallocated preprocessed entity from the external source. More...
virtual std::pair< unsigned, unsigned > | findPreprocessedEntitiesInRange (SourceRange Range)=0
| Returns a pair of [Begin, End) indices of preallocated preprocessed entities that `Range` encompasses. More...
virtual Optional< bool > | isPreprocessedEntityInFileID (unsigned Index, FileID FID)
| Optionally returns true or false if the preallocated preprocessed entity with index `Index` came from file `FID`. More...
virtual SourceRange | ReadSkippedRange (unsigned Index)=0
| Read a preallocated skipped range from the external source. More...

## Detailed Description

An abstract class that should be subclassed by any external source of preprocessing record entries.

Definition at line 280 of file PreprocessingRecord.h.

## Constructor & Destructor Documentation

## ◆ ~ExternalPreprocessingRecordSource()

ExternalPreprocessingRecordSource::~ExternalPreprocessingRecordSource | ( |  | ) |
| virtual default

## Member Function Documentation

## ◆ findPreprocessedEntitiesInRange()

virtual std::pair<unsigned, unsigned> clang::ExternalPreprocessingRecordSource::findPreprocessedEntitiesInRange | ( | SourceRange | Range | ) |
| pure virtual

Returns a pair of [Begin, End) indices of preallocated preprocessed entities that `Range` encompasses.

Implemented in clang::ASTReader.

Referenced by clang::PreprocessingRecord::isEntityInFileID().

## ◆ isPreprocessedEntityInFileID()

virtual Optional<bool> clang::ExternalPreprocessingRecordSource::isPreprocessedEntityInFileID | ( | unsigned | Index,
|  | FileID | FID
| ) |  |
| inline virtual

Optionally returns true or false if the preallocated preprocessed entity with index `Index` came from file `FID`.

Reimplemented in clang::ASTReader.

Definition at line 297 of file PreprocessingRecord.h.

References clang::None.

Referenced by clang::PreprocessingRecord::isEntityInFileID().

## ◆ ReadPreprocessedEntity()

virtual PreprocessedEntity* clang::ExternalPreprocessingRecordSource::ReadPreprocessedEntity | ( | unsigned | Index | ) |
| pure virtual

Read a preallocated preprocessed entity from the external source.

Returns
  null if an error occurred that prevented the preprocessed entity from being loaded.

Implemented in clang::ASTReader.

## ◆ ReadSkippedRange()

virtual SourceRange clang::ExternalPreprocessingRecordSource::ReadSkippedRange | ( | unsigned | Index | ) |
| pure virtual

Read a preallocated skipped range from the external source.

Implemented in clang::ASTReader.

The documentation for this class was generated from the following files:

- include/clang/Lex/PreprocessingRecord.h
- lib/Lex/PreprocessingRecord.cpp